快捷搜索:
来自 计算机编程 2019-06-20 13:27 的文章
当前位置: 67677新澳门手机版 > 计算机编程 > 正文

面向对象之

周四多码文,前几天中午一篇,前天再来一篇:

在线编制程序:

在线预览:http://github.lesschina.com/python/base/oop/3.分外相关.html

代码裤子:

 

1.异常¶

1.1 try...except¶

又到了开新课的时候了,小明同学此番提前预习了文化,乘着老师还没来就在黑板上写下了这段Code:

In [1]:

def main():
    try:
        1 / 0  # ZeroDivisionError: division by zero
    except ZeroDivisionError as ex:
        print(ex)


if __name__ == '__main__':
    main()

 

division by zero

 

1.2 try...except...else...finally¶

小潘同学刚进去就映重点帘了,自语道:“try...except破获分外何人不会?就能如此屁点东西万幸意思秀,切~ 小编给您把 格式补全”

于是乘着小明上厕所的时候,擦掉小明的Code,自身写了一段高大上的Code:

In [2]:

# 异常捕获全格式
def test(input_str):
    try:
        eval(input_str)
    except ZeroDivisionError as ex:
        print("except:", ex)
    else:
        print("else:没有异常就奖励100块~")
    finally:
        print("finally:小明是傻子~")


def main():
    test("1/0")
    print("-" * 10)
    test("print('小明啊小明你调坑里了~')")


if __name__ == '__main__':
    main()

 

except: division by zero
finally:小明是傻子~
----------
小明啊小明你调坑里了~
else:没有异常就奖励100块~
finally:小明是傻子~

 

那会儿小明和名师一起进入了,同学们隐隐间都听见小明的自夸声:“老师,小编可好了,提前预习并且还写了个demo在黑板上呢~”

先生一进门望着黑板就笑了,同学们也笑成一片。小明心想,咦~难道笔者写错了?定眼一看黑板,气呼呼的回座位了

else能够不写,不过大家 大概还是会写的,终究能够精晓是的确没错误,而不是遮挡了不当

1.3 四个特别管理¶

导师很安慰,感觉那么些班真风趣,咱们学习空前热情,为了照料小明,老师反问道:“有哪个人知道 多个十三分怎么管理?”

小明神速的举手并把黑板上内容擦完,写下了如下代码:

In [3]:

# 多个异常捕获
def main():
    try:
        print(xiaopan)  # NameError: name 'xiaopan' is not defined
        1 / 0  # ZeroDivisionError: division by zero
    except NameError as ex:
        print(ex)
    except ZeroDivisionError as ex:
        print(ex)

if __name__ == '__main__':
    main()

 

name 'xiaopan' is not defined

 

师资问了小雅培声,有多少个出口?

小明骄傲的说道:“几个,我写了多个要命管理,当然都施行了”

校友们又笑了,小潘作弄的说了句:“一看就精通二〇一八年C#没好好学,这不都无差异嘛,遇上特别下边代码还执行吗?用心血好好思考”

当大家以为某个代码只怕会出错时,就足以用try来运维这段代码,假设进行出错,则一而再代码不会继续施行,而是一贯跳转至except语句块,执行完except后,如果有finally语句块,则执行finally语句块

小明又难堪了。。。

1.4 多分外简写¶

教员职员和工人再次帮小明圆了个场:“已经很不简单了,就是最后小得意的时候口误了,那小明同学你了然Python里面多极度有个方便人民群众写法吗?”

小明赶紧拿起粉笔刷刷刷的写完,然后说道:“of course

In [4]:

# 多个异常捕获的简写(注意哦,是元组哦)
def main():
    try:
        print(xiaopan)  # NameError: name 'xiaopan' is not defined
        1 / 0  # ZeroDivisionError: division by zero
    except (NameError, ZeroDivisionError) as ex:
        print(ex)


if __name__ == '__main__':
    main()

 

name 'xiaopan' is not defined

 

教员职员和工人赶紧夸了夸小明,心想,哎呦喂终于把那难缠的钱物弄回座位了。

小明走前还不忘说一句:“简写的时候注意格式哦,是 元组 不是逗号分隔”

教工那堂课很自在,大家都预习了相同的时候内容也相比较简单。

随后以咨询的艺术问道:“小潘同学,你知道特其他基类是何等吧?假如要捕获全数极度该怎么办啊?”

小潘站起来讲道:“是BaseException

助教增添道:“全体的失实类型都持续自BaseException,所以在选用except时索要留意的是,它不止捕获该类型的一无所能,还把其子类也联合抓获了”

由此一般在捕获相当的时候 把子类十分放在前方,父类放在前面

看如下代码:

In [5]:

def main():
    try:
        1 / 0  # ZeroDivisionError: division by zero
    except BaseException as ex:
        print("base:", ex)
    except ZeroDivisionError as ex:
        print(ex)


if __name__ == '__main__':
    main()

 

base: division by zero

 

若果把父类放第三个,那么ZeroDivisionError恒久也不会被实施了,其实您只要装了 代码标准提醒插件会提醒您的

能够参见作者事先写的 vscode设置python3调治将养遭遇的恢宏部分

来个通用分外捕获的简写(官方不推荐使用简写):

In [6]:

# 直接except就行了
def main():
    try:
        1 / 0
        dnt  = 1
    except:
        print("屏蔽错误")


if __name__ == '__main__':
    main()

 

屏蔽错误

 

教育工笔者继续讲到,大家来看叁个场所,以后数不尽在线编辑器,你在她们这几个编辑框里写下了代码也许有非常抛出的,那是怎么管理的呢?

微软有开源代码编辑器相比较受接待(VSCode的一片段):monaco-editor

提示一下,假若真的要做在线编辑器,记得考虑一下fork炸弹,那么些实际也是很老的东西了,程序员基本上都应有接触过了

1.5 抛出特别¶

咱俩后续,像C#是用thorw抛出十分,这Python怎么 捕获异常后再抛出 呢?怎么自定义异常 呢?

承接往下看:

In [7]:

# 捕获异常后再丢出,eg:在线运行的用户Code
def main():
    try:
        1 / 0  # ZeroDivisionError: division by zero
    except ZeroDivisionError as ex:
        print(ex)  # 写个日志,回头出问题可以深究
        raise


if __name__ == '__main__':
    main()

 

division by zero

 

---------------------------------------------------------------------------
ZeroDivisionError                         Traceback (most recent call last)
<ipython-input-7-15f01346e2d8> in <module>()
      9 
     10 if __name__ == '__main__':
---> 11main()

<ipython-input-7-15f01346e2d8> in main()
      2 def main():
      3     try:
----> 41 / 0  # ZeroDivisionError: division by zero
      5     except ZeroDivisionError as ex:
      6         print(ex)  # 写个日志,回头出问题可以深究

ZeroDivisionError: division by zero

In [8]:

# 抛出自定义异常
class DntException(BaseException):
    pass


def get_age(num):
    if num <= 0:
        raise DntException("num must>0")
    else:
        print(num)


def main():
    get_age(-1)
    get_age(22)  # 程序崩了,这句话不会被执行了


if __name__ == '__main__':
    main()

 

---------------------------------------------------------------------------
DntException                              Traceback (most recent call last)
<ipython-input-8-7c9dec6ec225> in <module>()
     17 
     18 if __name__ == '__main__':
---> 19main()

<ipython-input-8-7c9dec6ec225> in main()
     12 
     13 def main():
---> 14get_age(-1)
     15     get_age(22)  # 程序崩了,这句话不会被执行了
     16 

<ipython-input-8-7c9dec6ec225> in get_age(num)
      6 def get_age(num):
      7     if num <= 0:
----> 8raise DntException("num must>0")
      9     else:
     10         print(num)

DntException: num must>0

 

丰盛这一块差不离讲完了(logging模块前边会说)有哪些补充的能够说的^_^

 

1.6 C#异常¶

小明又拓展了C#的代码调换,怎么看都是为依然C#大致啊,根本不用说吗,代码一贴就秒懂了。。。

In [1]:

%%script csharp
try
{
    Convert.ToInt32("mmd");
}
catch (Exception ex)
{
    // Input string was not in a correct format
    Console.WriteLine(ex.Message);
}

 

Input string was not in a correct format.

In [2]:

%%script csharp
//抛出自定义异常
try
{
    throw new Exception("出错了啊");
}
catch (Exception ex)
{
    Console.WriteLine(ex.Message);
}

 

出错了啊

 

您能够自定义十三分类,承继Exception就可以,对了C#里头也许有finally的

try
{
    throw new Exception("出错了啊");
    //Convert.ToInt32("mmd");
}
catch (Exception ex)
{
    // Input string was not in a correct format
    Console.WriteLine(ex.Message);
}
finally
{
    Console.WriteLine("finally");
}

近些日子某些亟待finally的地点多数都被using(){}接管了,所以一定情景会利用

先那样了

本文由67677新澳门手机版发布于计算机编程,转载请注明出处:面向对象之

关键词: